'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               PhotoSetup                                 |
'|                                                                          |
'|                        Skinned GDImage project                           |
'|         to adjust color settings and remove red-eye from photo.          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'|  If you are not a registered user of GDImage, then you are not allowed   |
'|  to produce derivated work or any translation of this code to another    |
'|  language, without the written permission of the author.                 |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 07-14-2008 (MM-DD-YYYY)            |
'|                        Last revised : 12-02-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "PhotoSetup.exe"
'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%FW_BOLD                  = 700
%GWL_WNDPROC              = -4
%WS_EX_STATICEDGE         = &H00020000

%HKEY_LOCAL_MACHINE       = &H80000002???
%HKEY_CURRENT_USER        = &H80000001???
%REG_SZ                   = 1     ' Unicode nul terminated string
%STANDARD_RIGHTS_READ     = &H00020000
%STANDARD_RIGHTS_WRITE    = &H00020000
%KEY_QUERY_VALUE          = &H1
%KEY_SET_VALUE            = &H2
%KEY_CREATE_SUB_KEY       = &H4
%KEY_ENUMERATE_SUB_KEYS   = &H8
%KEY_NOTIFY               = &H10
%SYNCHRONIZE              = &H00100000

%VK_PRIOR                 = &H21
%VK_NEXT                  = &H22
%VK_END                   = &H23
%VK_HOME                  = &H24
%VK_LEFT                  = &H25
%VK_NUMPAD4               = &H64
%VK_UP                    = &H26
%VK_NUMPAD8               = &H68
%VK_RIGHT                 = &H27
%VK_NUMPAD6               = &H66
%VK_DOWN                  = &H28
%VK_NUMPAD2               = &H62

TYPE DEV_BROADCAST_HDR
  dbch_size       AS DWORD
  dbch_devicetype AS DWORD
  dbch_reserved   AS DWORD
END TYPE

TYPE DEV_BROADCAST_VOLUME
  dbch_size       AS DWORD
  dbch_devicetype AS DWORD
  dbch_reserved   AS DWORD
  dbcv_unitmask   AS DWORD
  dbcv_flags      AS WORD
END TYPE

%WM_DEVICECHANGE          = &H219
%DBTF_MEDIA               = &H1&     ' media comings and goings
%DBT_DEVTYP_VOLUME        = &H2&     ' logical volume
%DBT_DEVICEARRIVAL        = &H8000&  ' system detected a new devic
%DBT_DEVICEREMOVECOMPLETE = &H8004&  ' device is gone
%DRIVE_UNKNOWN            = 0
%DRIVE_NO_ROOT_DIR        = 1
%DRIVE_REMOVABLE          = 2
%DRIVE_FIXED              = 3
%DRIVE_REMOTE             = 4
%DRIVE_CDROM              = 5
%DRIVE_RAMDISK            = 6
DECLARE FUNCTION RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GetDriveType LIB "KERNEL32.DLL" ALIAS "GetDriveTypeA" (nDrive AS ASCIIZ) AS DWORD

%WM_DROPFILES = &H233

DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD

%XMIN_SIZE = 800
%YMIN_SIZE = 600

%ID_BACKGROUND          = -999
%ID_CTRL                = -1
%ID_PHOTO               = 1

%ID_GDIMAGE             = 9
%ID_FRAMEBUTTON         = 10
%ID_NEW_IMAGE           = 11
%ID_RESET               = 12

%ID_LIB_ZOOM            = 13
%ID_TRACK_ZOOM          = 14
%ID_LIB_ROTATION        = 15
%ID_TRACK_ROTATION      = 16
%ID_LIB_ALPHA           = 17
%ID_TRACK_ALPHA         = 18
%ID_LIB_BRIGHTNESS      = 19
%ID_TRACK_BRIGHTNESS    = 20
%ID_LIB_CONTRAST        = 21
%ID_TRACK_CONTRAST      = 22
%ID_LIB_RED             = 23
%ID_TRACK_RED           = 24
%ID_LIB_GREEN           = 25
%ID_TRACK_GREEN         = 26
%ID_LIB_BLUE            = 27
%ID_TRACK_BLUE          = 28
%ID_LIB_HUE             = 29
%ID_TRACK_HUE           = 30

%ID_APPLY               = 31

%ID_GLASS_OPACITY_LABEL = 32
%ID_TRACK_OPACITY       = 33
%ID_AEROCRYSTAL         = 34
%ID_AEROBLUR            = 35

%ID_BACK_LIST           = 36

%ID_BTN_ABOUT           = 37
%ID_STATUSBAR           = 38
%ID_STATUSTIP           = 39

%ID_LIB_NAME            = 40
%ID_LIB_SIZE            = 41
%ID_BTN_BACKL           = 42
%ID_BTN_BACKR           = 43
%ID_LIB_BACK            = 44

%ID_BTN_HELP            = 45

%ID_COMPOSITED          = 47
%ID_BTN_SAVE            = 48
%ID_STATUSMESSAGE       = 49
%ID_BTN_CROP            = 50
%ID_BTN_REDEYE          = 51

%AERO_TIMER             = 1

GLOBAL gnCtrl, gMainWnd AS DWORD
GLOBAL gnFocusID, gnTrueWidth, gnTrueHeight, gnUseWidth, gnUseHeight AS LONG
GLOBAl grAspect, grWasZoom AS SINGLE
'//GLOBAL gbZoomFocus, gbRotationFocus, gbAlphaFocus, gbBrightnessFocus, gbContrastFocus, gbRedFocus, gbGreenFocus, gbBlueFocus, gbHueFocus AS LONG
GLOBAL gnWasAngle, gnWasAlpha, gnWasBrightness, gnWasContrast, gnWasRed, gnWasGreen, gnWasBlue, gnWasHue AS LONG
GLOBAL gsImageFullPathName AS STRING

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZPHOTOSETUP"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "PhotoSetup"
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN
          
        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "PhotoSetupSkin.zsk")
          'CALL zInitSkin(gMainWnd, zsExePath() + "IpodSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()
          CALL GDImageEnableEvents()
          CALL GDImageBackground()
'         // Load default image
          CALL UseThisPhoto(zsExePath() + "Heart.png", %TRUE)

'         // To perform file drag and drop
          CALL DragAcceptFiles(gMainWnd, %TRUE)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the bakground listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind, BackgroundCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%ID_BACK_LIST)
    CALL ListDeleteAll(hList)

    WashFind = MyFindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR BackgroundCount
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    nSelected = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, nSelected)

    IF BackgroundCount < 2 THEN
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL x, y, hCtrl, imgW, imgH AS LONG
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    vgW = 596: vgH = 400
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 '%WS_EX_STATICEDGE
    gnCtrl = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           16, _                      ' initial x position
                           162, _                     ' initial y position
                           vgW, _                     ' Calculate Window Width
                           vgH, _                     ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl, %ANCHOR_HEIGHT_WIDTH)
    
'   ___________________

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 594, 40, 194, 81, %ID_GDIMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 627, 122, 158, 399, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________


    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Composited mode", 635, 127, 143, 22, %ID_COMPOSITED, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Enable or Disable the composited mode")

    sLabel = "Zoom"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 155, 140, 15, %ID_LIB_ZOOM, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 168, 140, 14, %ID_TRACK_ZOOM, 100, 1500, 500, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Magnification")

    sLabel = "Rotation"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 183, 140, 15, %ID_LIB_ROTATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 196, 140, 14, %ID_TRACK_ROTATION, 0, 360, 180, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Perform full 0-360 rotation")

    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 642, 215, 16, 47, %ID_TRACK_ALPHA, 255, 0, 255, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Opacity level")
    hCtrl = zStaticLabelEx(gMainWnd, "Alpha", 633, 268, 34, 16, %ID_LIB_ALPHA, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    hCtrl = zPushButtonEx(gMainWnd, (SK_FOLDER() + "BTN_Hover.png"), "", 690, 279, 32, 32, %ID_RESET, SK_BTNTEXTCOLOR(), 0, 0, (SK_FOLDER() + "Restore.png"))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Restore to initial state")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "SelectImage.png"), 683, 218, %ID_NEW_IMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Select a new picture")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_RedEye.png"), 732, 218, %ID_BTN_REDEYE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Remove red-eye")

    sLabel = "Brightness"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 314, 140, 15, %ID_LIB_BRIGHTNESS, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 327, 140, 14, %ID_TRACK_BRIGHTNESS, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the brightness level")

    sLabel = "Contrast"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 342, 140, 15, %ID_LIB_CONTRAST, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 355, 140, 14, %ID_TRACK_CONTRAST, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the contrast level")

    sLabel = "Red"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 370, 140, 15, %ID_LIB_RED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 383, 140, 14, %ID_TRACK_RED, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup red color level")

    sLabel = "Green"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 398, 140, 15, %ID_LIB_GREEN, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 411, 140, 14, %ID_TRACK_GREEN, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup green color level")

    sLabel = "Blue"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 426, 140, 15, %ID_LIB_BLUE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 439, 140, 14, %ID_TRACK_BLUE, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup blue color level")

    sLabel = "Hue"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 454, 140, 15, %ID_LIB_HUE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 467, 140, 14, %ID_TRACK_HUE, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the hue level")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_Push.png"), "Apply", 634, 488, 144, 24, %ID_APPLY, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Apply the new settings")

IF Vista() AND zDwmIsCompositionEnabled() THEN
    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Blur mode", 15, 41, 75, 22, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to BLUR mode")

    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Crystal", 100, 41, 60, 22, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to CRYSTAL mode")

    hCtrl = zStaticLabelEx(gMainWnd, "Client zone opacity", 14, 62, 140, 15, %ID_GLASS_OPACITY_LABEL, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 16, 75, 140, 14, %ID_TRACK_OPACITY, 0, 255, cAlpha, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "To change client opacity (AERO must be On)")
END IF

    hCtrl = zStaticLabelEx(gMainWnd, "", 14, 125, 600, 18, %ID_LIB_NAME, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    hCtrl = zStaticLabelEx(gMainWnd, "", 14, 143, 80, 18, %ID_LIB_SIZE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_BackL.png"), 690, 527, %ID_BTN_BACKL, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")
    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_BackR.png"), 708, 527, %ID_BTN_BACKR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")
    hCtrl = zStaticLabelEx(gMainWnd, "", 634, 544, 144, 18, %ID_LIB_BACK, SK_BTNTEXTCOLOR(), %BS_LABEL_CENTER, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %ID_BACK_LIST, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    CALL zGetSysIconXY(x,y)
    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), x, y, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 660, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_Push.png"), "Save to file", 625, 95, 162, 24, %ID_BTN_SAVE, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    'CALL zCreateToolTip(hCtrl, "Self adjustement to fit paper size and remove border band")
    CALL zCreateToolTip(hCtrl, "Use the PNG format to preserve variable opacity")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_Push.png"), "Crop to paper size", 14, 95, 162, 24, %ID_BTN_CROP, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Self adjustement to fit paper size and remove border band")

    sImageName = SK_FOLDER() + "StatusBar.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 0, %YMIN_SIZE - imgH, %XMIN_SIZE, imgH, %ID_STATUSBAR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    sImageName = SK_FOLDER() + "Tip.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 6, %YMIN_SIZE - imgH - 1, imgW, imgH, %ID_STATUSTIP, 0)
    CALL ShowWindow(hCtrl, %SW_HIDE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    hCtrl = zStaticLabelEx(gMainWnd, "", 26, %YMIN_SIZE - 19, %XMIN_SIZE - 45, 15, %ID_STATUSMESSAGE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, -1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)

END SUB

SUB GdimageResize()
    LOCAL lpr AS RECT, nX, nY, nSizeX, nSizeY AS LONG, rZoomValue AS SINGLE
    CALL GDImageBackground()
    '// Compute new range
    CALL GDImageSetZoomRange(gnUseWidth, gnUseHeight, nSizeX, nSizeY)
    rZoomValue = (nSizeX / (gnUseWidth / grAspect))
    CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ZOOM), CLNG(rZoomValue * 1000))
    CALL zSetProperty(zGetMainItem(%ID_TRACK_ZOOM), %TRACK_DEFAULT_VALUE, CLNG(rZoomValue * 1000))
    CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)
    CALL GetClientRect(gnCtrl, lpr)
    nX = (lpr.nRight - gnUseWidth) / 2
    nY = (lpr.nBottom - gnUseHeight) / 2
    CALL ZD_SetObjectXY(%ID_PHOTO, nX, nY, %FALSE)
    CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)

    CALL DisplayZoomValue()

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
END SUB

FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT, nRet, nObjectID, x, y, x1, y1, ObjectType, useWidth, useHeight, BoundWidth, BoundHeight AS LONG
    LOCAL x2Div2, y2Div2, useStep AS LONG

    nRet = %FALSE ' Do not stop the event processing in GDImage

    nObjectID = ZI_MouseOverObjectID()

    SELECT CASE LONG Msg

    CASE %WM_LBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN
               '//nSelected is int = ZD_GetObjectSelected(nObjectID)
               ObjectType = ZD_GetObjectType(nObjectID)
               IF (ObjectType = %OBJECT_BITMAP) OR (ObjectType = %OBJECT_TEXTBITMAP) THEN
                  IF gnFocusID <> nObjectID THEN
'//                     CALL GDImageChangeFocus(nObjectID)
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_LBUTTONUP
         IF nObjectID > 0 THEN CALL UpdateQualityStatus(%TRUE)

    CASE %WM_RBUTTONDOWN

    CASE %WM_MOUSEMOVE
         IF nObjectID > 0 THEN
            IF ZI_IsLButtonDown() THEN
               CALL UpdateQualityStatus(%FALSE)
            ELSE
               IF ZI_IsShiftKeyPressed() = %FALSE THEN CALL UpdateQualityStatus(%TRUE)
            END IF
         END IF

    CASE %WM_KEYDOWN
         nObjectID = ZI_GetObjectFocusID() '// Move the sprite that has the focus
         IF nObjectID > 0 THEN

            IF ZI_IsAnyArrowPressed() THEN
               CALL UpdateQualityStatus(%FALSE)
            END IF

            CALL ZD_GetObjectXY(nObjectID, x, y)
            x1 = x ' Make a copy to keep the orignal x location unchanged
            y1 = y ' Make a copy to keep the orignal y location unchanged
          ' Check accelerator keys to compute the step range
            IF ZI_IsCtrlKeyPressed THEN
               UseStep = 4
               IF ZI_IsShiftKeyPressed THEN UseStep = 16
            ELSEIF ZI_IsShiftKeyPressed THEN
               UseStep = 2
            ELSE
               UseStep = 1
            END IF

            IF ZD_GetObjectScroll(nObjectID) THEN ' If object scroll with the bitmap background
             ' Get the size of the bitmap background
               CALL ZI_GetBitmapSize(ZI_GetBMP(hWnd), useWidth, useHeight)
            ELSE
             ' Get the control client size
               CALL GetClientRect(hWnd, lpr)
               useWidth = lpr.nRight: useHeight = lpr.nBottom
            END IF
          ' Get the sprite object size
            CALL ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)

            x2Div2 = (BoundWidth \ 2): y2Div2 = BoundHeight \ 2

            SELECT CASE wParam
            CASE %VK_HOME
                 x1 = 0
            CASE %VK_END
                 x1 = MAX&(useWidth - BoundWidth, 0)
            CASE %VK_PRIOR
                 y1 = 0
            CASE %VK_NEXT
                 y1 = MAX&(useHeight - BoundHeight, 0)
            CASE %VK_LEFT, %VK_NUMPAD4
                 IF x1 > -x2Div2 THEN x1 = MAX&(x1 - UseStep, -x2Div2)
            CASE %VK_UP, %VK_NUMPAD8
                 IF y1 > -y2Div2 THEN y1 = MAX&(y1 - UseStep, -y2Div2)
            CASE %VK_RIGHT, %VK_NUMPAD6
                 IF x1 < useWidth - x2Div2 THEN
                    x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                 END IF
            CASE %VK_DOWN, %VK_NUMPAD2
                 IF y1 < useHeight - y2Div2 THEN
                 y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                 END IF
            END SELECT

            IF x <> x1 OR y <> y1 THEN
               x = x1: y = y1
               CALL ZD_SetObjectXY(nObjectID, x1, y1, %TRUE)
            END IF
         END IF
    CASE %WM_KEYUP
         IF ZI_IsAnyArrowPressed() = 0 THEN
            CALL UpdateQualityStatus(%TRUE)
         END IF
         
    CASE %WM_SIZE
         CALL GDImageResize()
         
    CASE %WM_MOUSEWHEEL
         IF ZI_IsShiftKeyPressed THEN
            CALL UpdateQualityStatus(%FALSE)
         ELSE
            CALL UpdateQualityStatus(%TRUE)
         END IF
    END SELECT

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL nRet, hDC, nFilesDropped, hList, nItem, Img, DoIt, hDW AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sDataString AS STRING
    LOCAL stZ AS ZOBJECT

    STATIC IsMoving AS LONG

    IF IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) THEN
       IF ZI_IsLButtonDown() = 0 THEN CALL ShowTip(%FALSE)
    END IF

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_DROPFILES '// Drag & drop 2007-11-24
         nFilesDropped = DragQueryFile(wParam, -1, "", 0)
         szFileName = ""
         IF nFilesDropped > 0 THEN
            CALL DragQueryFile(wParam, 0, szFileName, %MAX_PATH)
            sDataString = zCharLower(szFileName)
         END IF
         DoIt = 0
         IF RIGHT$(sDataString, 4) = ".jpg"  THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 4) = ".png"  THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 4) = ".bmp"  THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 4) = ".gif"  THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 4) = ".tif"  THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 5) = ".jpeg" THEN DoIt = -1: GOTO DropDone
         IF RIGHT$(sDataString, 5) = ".tiff" THEN DoIt = -1:
DropDone:
         IF DoIt THEN
            CALL SetForegroundWindow(hWnd)
            CALL UseThisPhoto(sDataString, %TRUE)
            CALL ZI_UpdateWindow(gnCtrl, 0)
         END IF
         CALL DragFinish(wParam)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_CTRL
              IF HIWRD(wParam) = %ZM_CropRedEye THEN
                 IF lParam = 1 THEN ' Menu Select
                    CALL ZI_GetCropCoordinates(x&, y&, UseWidth&, UseHeight&)           
                    'CALL ZI_RemoveRedEye(ZI_GetDC(GetDlgItem(hWnd, %ID_CTRL)), x&, y&, UseWidth&, UseHeight&)
                    CALL ZD_RemoveRedEyeFromBitmapObject(gnFocusID, x&, y&, UseWidth&, UseHeight&)
                 END IF
              END IF

         CASE %ID_TRACK_ZOOM
              CALL UseThisZoom()

         CASE %ID_TRACK_ROTATION
              CALL UseThisAngle()
      
         CASE %ID_TRACK_BRIGHTNESS
              CALL UseThisBrightness()

         CASE %ID_TRACK_ALPHA
              CALL UseThisAlpha()

         CASE %ID_TRACK_CONTRAST
              CALL UseThisContrast()
              
         CASE %ID_TRACK_RED
              CALL UseThisRed()
              
         CASE %ID_TRACK_GREEN
              CALL UseThisGreen()
              
         CASE %ID_TRACK_BLUE
              CALL UseThisBlue()
              
         CASE %ID_TRACK_HUE
              CALL UseThisHue()

         CASE %ID_APPLY
              IF gnFocusID THEN CALL ZD_RenderEffectToBitmapObject(gnFocusID, %TRUE)

              '// Restore the default Brightness
              gnWasBrightness = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BRIGHTNESS), gnWasBrightness)
              '// Restore the default Contrast
              gnWasContrast = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_CONTRAST), gnWasContrast)
              '// Restore the default Red level
              gnWasRed = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_RED), gnWasRed)
              '// Restore the default Green level
              gnWasGreen = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_GREEN), gnWasGreen)
              '// Restore the default Blue level
              gnWasBlue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BLUE), gnWasBlue)
              '// Restore the default Hue level
              gnWasHue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_HUE), gnWasHue)

         CASE %ID_BTN_SAVE
              IF LEN(gsImageFullPathName) THEN
                 hDW = ZI_CreateDW(hWnd)
                 CALL ZI_SetSaveDialogMsg("", zGetCTLText(zGetMainItem(%ID_BTN_Save)), "PhotoSetup")
                 szFileName = ZI_ChooseSaveFileName(hWnd, ((zsExePath() + "Result.png")))
                 CALL ZI_DestroyDW(hDW)
                 IF LEN(szFileName) THEN
                    CALL ZD_GetObjectProperties(%ID_PHOTO, stZ)                 
                    nRet = ZI_ApplyEffectToFile((gsImageFullPathName), stZ, szFileName)
                 END IF
              END IF

         CASE %ID_BTN_CROP
              IF LEN(gsImageFullPathName) THEN
                 hDW = ZI_CreateDW(hWnd)
                 CALL ZI_SetSaveDialogMsg("", zGetCTLText(zGetMainItem(%ID_BTN_Save)), "PhotoSetup")
                 szFileName = ZI_ChooseSaveFileName(hWnd, ((zsExePath() + "Cropped.png")))
                 CALL ZI_DestroyDW(hDW)
                 IF LEN(szFileName) THEN
                    nRet = ZI_FitImageToPaper((gsImageFullPathName), 152, 102, szFileName)
                 END IF
              END IF

         CASE %ID_BTN_REDEYE
              IF LEN(gsImageFullPathName) THEN
                 CALL ZD_GetObjectProperties(%ID_PHOTO, stZ)
                 IF stZ.angle THEN
                    gnWasAngle = 180: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ROTATION), gnWasAngle): stZ.angle = 0
                    CALL DisplayRotationAngle()
                    CALL UseThisAngle()
                 END IF                 
                 CALL ZI_SetCropPopupText("Apply,Cancel") ' The text of the popup contextual menu
                 CALL ZI_EnableCropRedEye(GetDlgItem(hWnd, %ID_CTRL))
              END IF

         CASE %ID_RESET
              CALL UseThisPhoto(gsImageFullPathName, %TRUE)

         CASE %ID_COMPOSITED
              CALL GDImageBackground()
              CALL ZI_UpdateWindow(gnCtrl, %FALSE)

         CASE %ID_NEW_IMAGE
              hDW = ZI_CreateDW(hWnd)
              CALL ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_NEW_IMAGE)), zGetCTLText(zGetMainItem(%ID_BTN_Save)), "PhotoSetup")
              sDataString = ZI_LoadDialog(hWnd)
              CALL ZI_DestroyDW(hDW)
              IF LEN(sDataString) THEN
                 CALL UseThisPhoto(sDataString, %TRUE)
              END IF

         CASE %ID_AEROCRYSTAL
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
                 CALL ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)
                 CALL ZD_SetObjectVisibility(%ID_BACKGROUND, %TRUE)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
                 CALL ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)
                 CALL ZD_SetObjectVisibility(%ID_BACKGROUND, %TRUE)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_TRACK_OPACITY
              IF SK_AEROEMULATE() THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                 CALL zUpdateWindow(hWnd, 0)
              END IF

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_BACKL
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

              END IF

         CASE %ID_BTN_BACKR
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

              END IF

         CASE %ID_BTN_HELP

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'   //START AERO section ---------------------------------------------------------
    CASE %WM_TIMER
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               IF zIsLButtonDown() = 0 THEN IsMoving = 0
               IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                  CALL GetWindowRect(hWnd, rc)
                  CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                  CALL zUpdateWindow(hWnd, 0)
               END IF
            END IF
         END IF

    CASE %WM_NCLBUTTONDOWN
         IsMoving = -1

    CASE %WM_MOVING
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               DIM rw AS RECT PTR
               rw = lparam
               CALL zMoveBackground(@rw.nLeft, @rw.nTop, 0)
               CALL zUpdateWindow(hWnd, 0)
               FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
'   //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageEnableEvents()
    LOCAL lpCallBack AS DWORD
    lpCallBack = CODEPTR(GDImageCallBack)
    CALL ZI_EventMessage(lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_LBUTTONUP, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_KEYDOWN, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_KEYUP, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_MOUSEMOVE, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_NCHITTEST, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_MOUSEWHEEL, %TRUE)
    CALL ZI_EventMessage(lpCallBack, %WM_SIZE, %TRUE)
END SUB

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG
    LOCAL nUseState AS LONG

    CALL GetWindowRect(gnCtrl, lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)
    IF zGetCheckButtonStatus(zGetMainItem(%ID_COMPOSITED)) THEN

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) OR zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
               nUseState = %ZS_HIDDEN
          ELSE
               nUseState = %ZS_VISIBLE
          END IF
          CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, nUseState)
          CALL GdipDeleteGraphics(graphics)

          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the backround is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)
    ELSE
       CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, RGB(0,0,0))
       CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, RGB(128,128,128))
       IF ZD_IsObjectVisible(%ID_BACKGROUND) THEN ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)
    END IF

END SUB

SUB GDImageSetZoomRange(BYVAL bmW AS LONG, BYVAL bmH AS LONG, xSize AS LONG, ySize AS LONG)
    LOCAL lpr AS RECT, xPos, yPos AS LONG
    CALL GetClientRect(gnCtrl, lpr)
    CALL ZI_Iconise(bmW, bmH, lpr.nRight, lpr.nBottom, xPos, yPos, xSize, ySize)
    CALL zSetTrackMinMax(zGetMainItem(%ID_TRACK_ZOOM), CLNG((xSize / bmW) * 128), 1500)
END SUB

SUB UseThisPhoto(BYVAL sUsePhoto AS STRING, BYVAL bReset AS LONG)
    LOCAL lpr AS RECT, rZoomValue AS SINGLE
    LOCAL nHbitmap, nW, nH, nX, nY, nSizeX, nSizeY AS LONG

    '// Make sure to disable the crop rectangle if any
    IF ZI_GetToolCropStatus(gnCtrl) THEN ZI_DisableCropRectangle(gnCtrl)

    CALL ZI_GetImageSizeFromFile((sUsePhoto), gnTrueWidth, gnTrueHeight)
    nW = MAX&(gnTrueWidth, gnTrueHeight): IF nW > 1024 THEN nW = 1024
    nHbitmap = ZI_FitBitmapFromFile((sUsePhoto), nW, nW)

    CALL ZI_GetBitmapSize(nHbitmap, nW, nH)

    IF nHbitmap THEN
       gnUseWidth = nW: gnUseHeight = nH
'
       gsImageFullPathName = sUsePhoto
       CALL zSplitN(sUsePhoto, "", sUsePhoto): sUsePhoto = UCASE$(LEFT$(sUsePhoto, 1)) + LCASE$(MID$(sUsePhoto, 2))
       CALL zSetCTLText(zGetMainItem(%ID_LIB_NAME), (sUsePhoto))
       CALL zSetCTLText(zGetMainItem(%ID_LIB_SIZE), (LTRIM$(STR$(gnTrueWidth)) + " x" + STR$(gnTrueHeight)))
'
       '// Compute range based on the image size
       CALL GDImageSetZoomRange(gnUseWidth, gnUseHeight, nSizeX, nSizeY)
'
       CALL GetClientRect(gnCtrl, lpr)
       CALL ZI_Iconise(gnTrueWidth, gnTrueHeight, lpr.nRight, lpr.nBottom, nX, nY, nW, nH)
       IF nW > nH THEN
          grAspect = nW / nH
       ELSE
          grAspect = 1
       END IF

       rZoomValue = (nSizeX / (gnUseWidth / grAspect))
       CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ZOOM), CLNG(rZoomValue * 1000))
       CALL zSetProperty(zGetMainItem(%ID_TRACK_ZOOM), %TRACK_DEFAULT_VALUE, CLNG(rZoomValue * 1000))
       CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)
       CALL GetClientRect(gnCtrl, lpr)
       nX = (lpr.nRight - gnUseWidth) / 2
       nY = (lpr.nBottom - gnUseHeight) / 2

       CALL ZD_SetObjectAngle(%ID_PHOTO, 0, %FALSE)

       CALL ZD_DrawBitmapToCtrl(gnCtrl, nX, nY, nHbitmap, ZD_ColorARGB(255, 0), %ID_PHOTO, %ZS_HIDDEN) '// %ZS_VISIBLE)
       CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)

       '// Turn on high quality display
       CALL UpdateQualityStatus(%TRUE)

       '// We need to use PNG opacity with ID_PHOTO, or we won't be able to resize it
       CALL ZD_UsePngOpacity(%ID_PHOTO, %TRUE)

       CALL SetFocus(gnCtrl)
       CALL ZI_SetObjectFocusID(%ID_PHOTO)
       gnFocusID = %ID_PHOTO

       IF bReset THEN 
          CALL GDImageResetImage(gnCtrl, %ID_PHOTO)
       END IF
       CALL ZD_SetObjectVisibility(%ID_PHOTO, %ZS_VISIBLE)
       CALL ZI_UpdateWindow(gnCtrl, 0)
    END IF
END SUB

SUB DisplayZoomValue()
    IF gnFocusID THEN 
       LOCAL sLabel AS STRING
       sLabel = EXTRACT$(zGetCTLText(zGetMainItem(%ID_LIB_ZOOM)), " ") + USING$(" #.##", ZD_GetObjectScale(gnFocusID))
       CALL zSetCTLText(zGetMainItem(%ID_LIB_ZOOM), (sLabel))
    END IF
END SUB
SUB UseThisZoom()
    IF gnFocusID THEN 
       LOCAL nCtrl AS LONG, rZoomValue AS SINGLE
       CALL UpdateQualityStatus(NOT ZI_IsLButtonDown())
    
       CALL DisplayMessageTip()
    
       rZoomValue = zGetTrackValue(zGetMainItem(%ID_TRACK_ZOOM)) / 1000
       IF rZoomValue <> grWasZoom THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
    
          CALL ZD_SetObjectScale(gnFocusID, rZoomValue)
          CALL ZI_UpdateWindow(nCtrl, %FALSE)
          CALL DisplayZoomValue()
       END IF
       grWasZoom = rZoomValue
    END IF
END SUB

SUB DisplayRotationAngle()
    IF gnFocusID THEN 
       LOCAL sLabel AS STRING    
       sLabel = EXTRACT$(zGetCTLText(zGetMainItem(%ID_LIB_ROTATION)), " ") + STR$(ZD_GetObjectAngle(gnFocusID))+ ""
       CALL zSetCTLText(zGetMainItem(%ID_LIB_ROTATION), (sLabel))
    END IF
END SUB
SUB UseThisAngle()
    IF gnFocusID THEN
       LOCAL nCtrl, nAngle AS LONG
       CALL UpdateQualityStatus(NOT ZI_IsLButtonDown())
    
       CALL DisplayMessageTip()
    
       nAngle = zGetTrackValue(zGetMainItem(%ID_TRACK_ROTATION)) + 180: IF nAngle > 359 THEN nAngle = nAngle - 360
       IF nAngle <> gnWasAngle THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
    
          CALL ZD_SetObjectAngle(gnFocusID, nAngle, %TRUE)
          CALL DisplayRotationAngle()
       END IF
       gnWasAngle = nAngle
    END IF
END SUB

SUB DisplayThisValue(BYVAL nID AS LONG)
    IF gnFocusID THEN 
       LOCAL sLabel AS STRING
       sLabel = EXTRACT$(zGetCTLText(zGetMainItem(nID)), " ") + USING$(" #.##", (zGetTrackValue(zGetMainItem(nID + 1)) + 1) / 128)
       CALL zSetCTLText(zGetMainItem(nID), (sLabel))
    END IF
END SUB

SUB DisplayBrightnessValue()
    CALL DisplayThisValue(%ID_LIB_BRIGHTNESS)
END SUB
SUB UseThisBrightness()
    IF gnFocusID THEN
       LOCAL nCtrl, nBrightness AS LONG
       'CALL DisplayMessageTip()
       nBrightness = zGetTrackValue(zGetMainItem(%ID_TRACK_BRIGHTNESS))
       IF nBrightness <> gnWasBrightness THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectBrightness(gnFocusID, nBrightness, %TRUE)
       END IF
       gnWasBrightness = nBrightness
    END IF
END SUB

SUB DisplayContrastValue()
    CALL DisplayThisValue(%ID_LIB_CONTRAST)
END SUB
SUB UseThisContrast()
    IF gnFocusID THEN
       LOCAL nCtrl, nContrast AS LONG
       'CALL DisplayMessageTip()
       nContrast = zGetTrackValue(zGetMainItem(%ID_TRACK_CONTRAST))
       IF nContrast <> gnWasContrast THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectContrast(gnFocusID, nContrast, %TRUE)
          CALL DisplayContrastValue()
       END IF
       gnWasContrast = nContrast
    END IF
END SUB

SUB UseThisAlpha()
    IF gnFocusID THEN
       LOCAL nCtrl, nAlpha AS LONG
       CALL DisplayMessageTip()
       nAlpha = zGetTrackValue(zGetMainItem(%ID_TRACK_ALPHA))
       IF nAlpha <> gnWasAlpha THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectAlpha(gnFocusID, nAlpha, %TRUE)
       END IF
       gnWasAlpha = nAlpha
    END IF
END SUB

SUB DisplayRedValue()
    CALL DisplayThisValue(%ID_LIB_RED)
END SUB
SUB UseThisRed()
    IF gnFocusID THEN 
       LOCAL nCtrl, nRed AS LONG
       'CALL DisplayMessageTip()
       nRed = zGetTrackValue(zGetMainItem(%ID_TRACK_RED))
       IF nRed <> gnWasRed THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectRed(gnFocusID, nRed, %TRUE)
          CALL DisplayRedValue()
       END IF
       gnWasRed = nRed
    END IF
END SUB

SUB DisplayGreenValue()
    CALL DisplayThisValue(%ID_LIB_GREEN)
END SUB
SUB UseThisGreen()
    IF gnFocusID THEN
       LOCAL nCtrl, nGreen AS LONG
       'CALL DisplayMessageTip()
       nGreen = zGetTrackValue(zGetMainItem(%ID_TRACK_GREEN))
       IF nGreen <> gnWasGreen THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectGreen(gnFocusID, nGreen, %TRUE)
          CALL DisplayGreenValue()
       END IF
       gnWasGreen = nGreen 
    END IF
END SUB

SUB DisplayBlueValue()
    CALL DisplayThisValue(%ID_LIB_BLUE)
END SUB
SUB UseThisBlue()
    IF gnFocusID THEN
       LOCAL nCtrl, nBlue AS LONG
       'CALL DisplayMessageTip()
       nBlue = zGetTrackValue(zGetMainItem(%ID_TRACK_BLUE))
       IF nBlue <> gnWasBlue THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectBlue(gnFocusID, nBlue, %TRUE)
          CALL DisplayBlueValue()
       END IF
       gnWasBlue = nBlue
    END IF
END SUB

SUB DisplayHueValue()
    CALL DisplayThisValue(%ID_LIB_HUE)
END SUB
SUB UseThisHue()
    IF gnFocusID THEN
       LOCAL nCtrl, nHue AS LONG
       'CALL DisplayMessageTip()
       nHue = zGetTrackValue(zGetMainItem(%ID_TRACK_HUE))
       IF nHue <> gnWasHue THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          '// On s'assure que le mode "Dlimite section" est dsactiv
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
      
          CALL ZD_SetObjectHue(gnFocusID, nHue, %TRUE)
          CALL DisplayHueValue()
       END IF
       gnWasHue = nHue 
    END IF
END SUB

SUB UpdateQualityStatus(BYVAL bQuality AS LONG)
    LOCAL nInterpolation AS LONG
    IF bQuality THEN
       nInterpolation = 2 ' %InterpolationModeHighQuality
    ELSE
       nInterpolation = 0 ' %InterpolationModeDefault
    END IF
    IF ZD_GetObjectQuality(%ID_PHOTO) <> nInterpolation THEN
       CALL ZD_SetObjectQuality(%ID_PHOTO, nInterpolation, %TRUE)
    END IF
END SUB

SUB GDImageResetImage(BYVAL nGDImageCtrl AS LONG, BYVAL nID_IMAGE AS LONG)
    '// Restore default zoom value
    LOCAL stZ AS ZOBJECT
    LOCAL lpr AS RECT
    LOCAL nX, nY, nSizeX, nSizeY AS LONG

    '// Get the GDImage objectproperties
    CALL ZD_GetObjectProperties(nID_IMAGE, stZ)

    '// Restore the default zoom value
    CALL GetClientRect(nGDImageCtrl, lpr)
    CALL ZI_Iconise(gnUseWidth, gnUseHeight, lpr.nRight, lpr.nBottom, nX, nY, nSizeX, nSizeY)
    stZ.scale = (nSizeX / (gnUseWidth / grAspect))
    grWasZoom = stZ.scale * 1000
    CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ZOOM), CLNG(grWasZoom))

    '// Restore the default rotation angle
    gnWasAngle = 180: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ROTATION), gnWasAngle): stZ.angle = 0
    '// Restore default opacity
    gnWasAlpha = 255: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ALPHA), gnWasAlpha): stZ.useARGB = ZD_ColorARGB(255, 0)
    '// Restore the default Brightness
    gnWasBrightness = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BRIGHTNESS), gnWasBrightness): stZ.brightness = 0
    '// Restore the default Contrast
    gnWasContrast = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_CONTRAST), gnWasContrast): stZ.contrast = 0
    '// Restore the default Red level
    '//IF ZD_GetObjectRed(nID_IMAGE) <> 0 THEN
    gnWasRed = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_RED), gnWasRed): stZ.red = 0
    '// Restore the default Green level
    gnWasGreen = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_GREEN), gnWasGreen): stZ.green = 0
    '// Restore the default Blue level
    gnWasBlue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BLUE), gnWasBlue): stZ.blue = 0
    '// Restore the default Hue level
    gnWasHue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_HUE), gnWasHue): stZ.Hue = 0

    '// Update the GDImage objectproperties
    CALL ZD_SetObjectProperties(nID_IMAGE, stZ)

    CALL DisplayZoomValue()
    CALL DisplayRotationAngle()
    CALL DisplayBrightnessValue()
    CALL DisplayContrastValue()
    CALL DisplayRedValue()
    CALL DisplayGreenValue()
    CALL DisplayBlueValue()
    CALL DisplayHueValue()
END SUB

SUB ShowTip(BYVAL bShowHide AS LONG)
    LOCAL nUseState AS LONG, sMessage AS STRING
    IF bShowHide THEN
       nUseState = %SW_SHOW 
       sMessage = "TIP: clic with the right mouse button to restore the default value while hover a slider."
    ELSE 
       nUseState = %SW_HIDE
       sMessage = ""
    END IF 
    CALL ShowWindow(zGetMainItem(%ID_STATUSTIP), nUseState)
    CALL zSetCTLText(zGetMainItem(%ID_STATUSMESSAGE), (sMessage))
END SUB

SUB DisplayMessageTip()
    IF ZI_IsLButtonDown() AND IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) = 0 THEN CALL ShowTip(%TRUE)
END SUB
